// Blueprint: auto-generated by Tracer plugin
package proc1

import (
	"gitlab.mpi-sws.org/cld/blueprint/blueprint-compiler/stdlib/components"
	"context"
	"go.opentelemetry.io/otel/trace"
	"spec/services"
)

type LeafServiceImplTracer struct {
	service *LeafServiceImpl
	tracer components.Tracer
	service_name string
}
func NewLeafServiceImplTracer(service *LeafServiceImpl,tracer components.Tracer,service_name string,sampling_rate string) *LeafServiceImplTracer {
	return &LeafServiceImplTracer{service: service, tracer: tracer, service_name: service_name}
}

func (t *LeafServiceImplTracer) Leaf(ctx context.Context, a int64, jaegerTracer_trace_ctx string) (int64, error) {
	if jaegerTracer_trace_ctx != "" {
		span_ctx_config, _ := components.GetSpanContext(jaegerTracer_trace_ctx)
		span_ctx := trace.NewSpanContext(span_ctx_config)
		ctx = trace.ContextWithRemoteSpanContext(ctx, span_ctx)
	}
	tp, _ := t.tracer.GetTracerProvider()
	tr := tp.Tracer(t.service_name)
	ctx, span := tr.Start(ctx, "Leaf")
	defer span.End()
	ret0, err := t.service.Leaf(ctx, a)
	if err != nil {
		span.RecordError(err)
	}
	return ret0, err
}

func (t *LeafServiceImplTracer) Object(ctx context.Context, obj services.LeafObject, jaegerTracer_trace_ctx string) (services.LeafObject, error) {
	if jaegerTracer_trace_ctx != "" {
		span_ctx_config, _ := components.GetSpanContext(jaegerTracer_trace_ctx)
		span_ctx := trace.NewSpanContext(span_ctx_config)
		ctx = trace.ContextWithRemoteSpanContext(ctx, span_ctx)
	}
	tp, _ := t.tracer.GetTracerProvider()
	tr := tp.Tracer(t.service_name)
	ctx, span := tr.Start(ctx, "Object")
	defer span.End()
	ret0, err := t.service.Object(ctx, obj)
	if err != nil {
		span.RecordError(err)
	}
	return ret0, err
}

