// Blueprint: auto-generated by Tracer plugin
package proc3

import (
	"gitlab.mpi-sws.org/cld/blueprint/blueprint-compiler/stdlib/components"
	"context"
	"go.opentelemetry.io/otel/trace"
)

type WebServiceImplTracer struct {
	service *WebServiceImpl
	tracer components.Tracer
	service_name string
}
func NewWebServiceImplTracer(service *WebServiceImpl,tracer components.Tracer,service_name string,sampling_rate string) *WebServiceImplTracer {
	return &WebServiceImplTracer{service: service, tracer: tracer, service_name: service_name}
}

func (t *WebServiceImplTracer) Hello(ctx context.Context, world string, jaegerTracer_trace_ctx string) (string, error) {
	if jaegerTracer_trace_ctx != "" {
		span_ctx_config, _ := components.GetSpanContext(jaegerTracer_trace_ctx)
		span_ctx := trace.NewSpanContext(span_ctx_config)
		ctx = trace.ContextWithRemoteSpanContext(ctx, span_ctx)
	}
	tp, _ := t.tracer.GetTracerProvider()
	tr := tp.Tracer(t.service_name)
	ctx, span := tr.Start(ctx, "Hello")
	defer span.End()
	ret0, err := t.service.Hello(ctx, world)
	if err != nil {
		span.RecordError(err)
	}
	return ret0, err
}

func (t *WebServiceImplTracer) Leaf(ctx context.Context, a int64, jaegerTracer_trace_ctx string) (int64, error) {
	if jaegerTracer_trace_ctx != "" {
		span_ctx_config, _ := components.GetSpanContext(jaegerTracer_trace_ctx)
		span_ctx := trace.NewSpanContext(span_ctx_config)
		ctx = trace.ContextWithRemoteSpanContext(ctx, span_ctx)
	}
	tp, _ := t.tracer.GetTracerProvider()
	tr := tp.Tracer(t.service_name)
	ctx, span := tr.Start(ctx, "Leaf")
	defer span.End()
	ret0, err := t.service.Leaf(ctx, a)
	if err != nil {
		span.RecordError(err)
	}
	return ret0, err
}

